#pragma once

#include <string>
#include <vector>

typedef std::vector<std::wstring> wstrvctr_t;

class CParseTree
{
public:
	CParseTree();
	~CParseTree();

	int RunParser(const std::string& filename = "");

	void SayHello(char* const msg) const;

	void copy_cstr(char** pTarget, const char* pSource);
	void copy_int(int& Target, const char* pSource);

	void PutErrorMsg(const char* msg);
	void PutErrorMsg(const wchar_t* msg);

	void PutResult(double rlt);
	const wstrvctr_t& GetMessages() const
	{
		return this->m_msgvctr;
	}

	double GetResult() const { return this->m_result;  }

	int CalculateCell(int index, const std::wstring& code);
protected:
	wstrvctr_t m_msgvctr;
	double m_result;
	int m_cell_index;
};

